.386
.model flat,stdcall
option casemap:none

;include		\LEMKE\MyDefs.inc
;include		\LEMKE\MyEqus.inc
;include		\LEMKE\MyStructs.inc
;include		\LEMKE\MyProtos.inc

;includelib	\LEMKE\Lib\kernel32.lib
;includelib	\LEMKE\Lib\user32.lib
;includelib	\LEMKE\Lib\gdi32.lib
;includelib	\LEMKE\Lib\comctl32.lib
;includelib	\LEMKE\Lib\comdlg32.lib
;includelib	\LEMKE\Lib\opengl32.lib

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\gdi32.inc
include \masm32\include\comctl32.inc
include \masm32\include\comdlg32.inc
include \masm32\include\opengl32.inc
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\comdlg32.lib
includelib \masm32\lib\opengl32.lib

WinMain		PROTO :DWORD,:DWORD,:DWORD,:DWORD

TPFTextProc			PROTO :DWORD,:DWORD,:DWORD,:DWORD
TPFPalProc			PROTO :DWORD,:DWORD,:DWORD,:DWORD
TPFGLPalProc			PROTO :DWORD,:DWORD,:DWORD,:DWORD

.data

ZeroReal4		REAL4	0.0
OnethousandthReal4	REAL4	0.001
TwotenthReal4		REAL4	0.2
OneReal4		REAL4	1.0
OneReal8		REAL8	1.0
TwoFiftyFiveReal4	REAL4	255.0

Light_Position	REAL4	-1.0,1.0,1.0,0.0
Light_Diffuse	REAL4	0.6,0.8,0.9,1.0
Light_Ambient	REAL4	0.2,0.5,0.6,1.0

TPFPalClass	BYTE	"TPF0008",0
TPFTextClass	BYTE	"TPF0018",0

ClassName	BYTE	"OpenGLClass",0
AppName		BYTE	"OpenGL",0
szDarrel	BYTE	"Darrel",0
szLemke		BYTE	"Lemke",0
szDisplay	BYTE	"DISPLAY",0

TPFGLPalClass	BYTE	"TPF0017",0
ButtonClass	BYTE	"BUTTON",0
EditClass	BYTE	"EDIT",0
StaticClass	BYTE	"STATIC",0
szRotateX	BYTE	"Rotate X-axis",0
szRotateY	BYTE	"Rotate Y-axis",0
szRotateZ	BYTE	"Rotate Z-axis",0
szMSSansSerif	Byte	"MS Sans Serif",0
szTimesNewRoman	Byte	"Times New Roman",0
szText		Byte	"Text",0
szFont		Byte	"Font",0

.data?

hInstance	HINSTANCE	?
CommandLine	LPSTR		?

hwndGLText	HANDLE		?

hwnd		HANDLE		?
hIcon		HANDLE		?

hwndTPF3DPal	HANDLE		?
hwndX		HANDLE		?
hwndY		HANDLE		?
hwndZ		HANDLE		?
hwndText	HANDLE		?
hwndGLPal	HANDLE		?
hwndFont	HANDLE		?
hGLFont		HANDLE		?
hGLBrush	HANDLE		?

hTextFont	HANDLE		?

hDCComputer	HANDLE		?
hdcGL		HANDLE		?
hdcText		HANDLE		?

hrcGL		HANDLE		?

hbmpGL		HANDLE		?
hbmpText	HANDLE		?
hbmpOldGL	HANDLE		?
hbmpOldText	HANDLE		?

lpGLBits	DWORD		?
lpTextBits	DWORD		?

fontlist	DWORD		?
Size3DText	DWORD		?

RotX		REAL4		?
RotY		REAL4		?
RotZ		REAL4		?

fred		REAL4		?
fgreen		REAL4		?
fblue		REAL4		?

OpenGLFont	LOGFONT		<>
OpenGLXFont	LOGFONT		<>

SelectGLColor	CHOOSECOLOR	<>
SelectGLColors	COLORREF	16 dup(?)
SelectGLFont	CHOOSEFONT	<>

GLBitmapInfoHeader	BITMAPINFOHEADER	<>
TextBitmapInfoHeader	BITMAPINFOHEADER	<>

;g_window	GL_WINDOW	<>

PixelFormatDescriptor	PIXELFORMATDESCRIPTOR	<>

sz3DText	BYTE		256 dup(?)

.const

IDI_LOGO	equ		500

IDC_TPF3DPAL	equ		1

.code

Start:

	INVOKE	InitCommonControls					;comctl32.dll

	INVOKE	GetModuleHandle,NULL								;kernel32.dll

	mov	hInstance,eax
	mov	SelectGLColor.hInstance,eax
	mov	SelectGLFont.hInstance,eax
;	lea	edx,g_window
;	mov	(GL_WINDOW PTR[edx]).init.application.hInstance,eax
;	mov	(GL_WINDOW PTR[edx]).init.winwidth,1024			;SCREEN_WIDTH
;	mov	(GL_WINDOW PTR[edx]).init.winheight,1024		;SCREEN_HEIGHT
;	mov	(GL_WINDOW PTR[edx]).init.bitsPerPixel,32		;SCREEN_BPP

	INVOKE	GetCommandLine									;kernel32.dll

	mov	CommandLine,eax

	mov	SelectGLColor.lStructSize,sizeof CHOOSECOLOR
	lea	edx,SelectGLColors
	mov	SelectGLColor.lpCustColors,edx
	mov	SelectGLColor.Flags,CC_FULLOPEN or CC_RGBINIT
	mov	SelectGLColor.rgbResult,0FFFFFFh

	INVOKE	CreateSolidBrush,0FFFFFFh	;gdi32.dll

	mov	hGLBrush,eax

	mov	SelectGLFont.lStructSize,sizeof CHOOSEFONT
	mov	SelectGLFont.hDC,CF_SCREENFONTS
	lea 	edx,OpenGLFont
	mov	SelectGLFont.lpLogFont,edx
	mov	SelectGLFont.Flags,CF_INITTOLOGFONTSTRUCT or CF_SCREENFONTS or CF_EFFECTS or CF_TTONLY

	mov	OpenGLFont.lfHeight,8
	mov	OpenGLFont.lfWeight,FW_NORMAL
	mov	OpenGLFont.lfOutPrecision,OUT_RASTER_PRECIS
	mov	OpenGLFont.lfQuality,PROOF_QUALITY
	mov	OpenGLFont.lfPitchAndFamily,VARIABLE_PITCH or FF_SWISS
	mov	OpenGLXFont.lfHeight,12
	mov	OpenGLXFont.lfWeight,FW_NORMAL
	mov	OpenGLXFont.lfOutPrecision,OUT_RASTER_PRECIS
	mov	OpenGLXFont.lfQuality,PROOF_QUALITY
	mov	OpenGLXFont.lfPitchAndFamily,VARIABLE_PITCH or FF_SWISS
	lea	edx,OpenGLFont.lfFaceName

	push	ebx
;	push	edi

;	lea	edi,OpenGLXFont.lfFaceName
	lea	ebx,szMSSansSerif
	xor	ecx,ecx

OpenGL00000:

	mov	al,BYTE PTR[ebx+ecx]
	mov	BYTE PTR[edx+ecx],al
;	mov	BYTE PTR[edi+ecx],al
	inc	ecx
	or	al,al
	jnz	OpenGL00000

;	pop	edi
;	pop	ebx

	INVOKE	CreateFontIndirect,ADDR OpenGLFont

	mov	hGLFont,eax				;Normal Font

	INVOKE	CreateDC,ADDR szDisplay,NULL,NULL,NULL						;gdi32.dll

	mov	hDCComputer,eax

	lea	edx,GLBitmapInfoHeader
	xor	ecx,ecx

OpenGL00001:

	mov	(BITMAPINFOHEADER PTR[edx]).biSize,sizeof BITMAPINFOHEADER
	mov	(BITMAPINFOHEADER PTR[edx]).biWidth,100
	mov	(BITMAPINFOHEADER PTR[edx]).biHeight,100
	mov	(BITMAPINFOHEADER PTR[edx]).biPlanes,1
	mov	(BITMAPINFOHEADER PTR[edx]).biBitCount,32
	mov	(BITMAPINFOHEADER PTR[edx]).biCompression,BI_RGB
	mov	(BITMAPINFOHEADER PTR[edx]).biSizeImage,40000
	mov	(BITMAPINFOHEADER PTR[edx]).biXPelsPerMeter,0EC4h
	mov	(BITMAPINFOHEADER PTR[edx]).biYPelsPerMeter,0EC4h
	mov	(BITMAPINFOHEADER PTR[edx]).biClrUsed,0
	mov	(BITMAPINFOHEADER PTR[edx]).biClrImportant,0
	add	edx,sizeof BITMAPINFOHEADER
	inc	ecx
	cmp	cl,2
	jb	OpenGL00001

	lea	edx,GLBitmapInfoHeader
	mov	(BITMAPINFOHEADER PTR[edx]).biWidth,1024
	mov	(BITMAPINFOHEADER PTR[edx]).biHeight,1024
	mov	(BITMAPINFOHEADER PTR[edx]).biSizeImage,4194304

	mov	OpenGLFont.lfHeight,12
	lea	edx,OpenGLFont.lfFaceName

	push	edi

	lea	edi,OpenGLXFont.lfFaceName
	lea	ebx,szTimesNewRoman
	xor	ecx,ecx

OpenGL00002:

	mov	al,BYTE PTR[ebx+ecx]
	mov	BYTE PTR[edx+ecx],al
	mov	BYTE PTR[edi+ecx],al
	inc	ecx
	or	al,al
	jnz	OpenGL00002

	pop	edi
	pop	ebx

	mov	eax,OneReal4
	mov	fred,eax
	mov	fgreen,eax
	mov	fblue,eax

	INVOKE	WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT

	INVOKE	DeleteObject,hGLFont

	INVOKE	DeleteObject,hGLBrush

	INVOKE	ExitProcess,eax									;kernel32.dll

;include		\LEMKE\0ThePixelFactory\OpenGL\OpenGLWinMain.asm
;include		\LEMKE\0ThePixelFactory\OpenGL\OpenGLWndProc.asm
;include		\LEMKE\0ThePixelFactory\OpenGL\Draw3DText.asm
;include		\LEMKE\0ThePixelFactory\OpenGL\TPFTextProc.asm
;include		\LEMKE\0ThePixelFactory\OpenGL\TPFPalProc.asm
;include		\LEMKE\0ThePixelFactory\OpenGL\TPFGLPalProc.asm

include		OpenGLWinMain.asm
include		OpenGLWndProc.asm
include		Draw3DText.asm
include		TPFTextProc.asm
include		TPFPalProc.asm
include		TPFGLPalProc.asm

END Start