WinMain PROC hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL	wc:WNDCLASSEX
	LOCAL	msg:MSG
	LOCAL	Rect:RECT

;################################################################################
;#				Register Window Class 				#
;################################################################################

	mov	wc.cbSize,SIZEOF WNDCLASSEX
	mov	wc.style,CS_HREDRAW or CS_VREDRAW or CS_DBLCLKS
	mov	wc.lpfnWndProc,OFFSET WndProc
	mov	wc.cbClsExtra,NULL
	mov	wc.cbWndExtra,NULL

	push	hInstance
	pop	wc.hInstance

	INVOKE	LoadIcon,hInst,IDI_LOGO							;user32.dll

	mov 	hIcon,eax
	mov	wc.hIcon,eax
	mov	wc.hIconSm,eax

	INVOKE	LoadCursor,NULL,IDC_ARROW						;user32.dll

	mov	wc.hCursor,eax
	mov	wc.hbrBackground,COLOR_BACKGROUND+1
	mov	wc.lpszMenuName,NULL
	mov	wc.lpszClassName,OFFSET ClassName

	INVOKE	RegisterClassEx,ADDR wc							;user32.dll

	mov	wc.lpfnWndProc,OFFSET TPFTextProc					;PalProc
	mov	wc.lpszClassName,OFFSET TPFTextClass					;PalClass

	INVOKE	RegisterClassEx,ADDR wc							;user32.dll

	mov	wc.hbrBackground,COLOR_BTNFACE+1
	mov	wc.lpfnWndProc,OFFSET TPFPalProc					;PalProc
	mov	wc.lpszClassName,OFFSET TPFPalClass					;PalClass

	INVOKE	RegisterClassEx,ADDR wc							;user32.dll

	mov	wc.lpfnWndProc,OFFSET TPFGLPalProc
	mov	wc.lpszClassName,OFFSET TPFGLPalClass

	INVOKE	RegisterClassEx,ADDR wc							;user32.dll

;================================================================================

;################################################################################
;#				Create Window					#
;################################################################################

	INVOKE	SystemParametersInfo,SPI_GETWORKAREA,NULL,ADDR Rect,NULL		;user32.dll

	mov	eax,Rect.right
	sub	eax,Rect.left
	mov	edx,Rect.bottom
	sub	edx,Rect.top

	INVOKE	CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\			;user32.dll
		WS_OVERLAPPEDWINDOW or WS_VISIBLE or WS_CLIPCHILDREN,0,0,eax,edx,\
		NULL,NULL,hInstance,NULL

	mov	hwnd,eax
	mov	SelectGLColor.hwndOwner,eax
	mov	SelectGLFont.hwndOwner,eax

;================================================================================

	INVOKE	ShowWindow,hwnd,SW_SHOWNORMAL						;user32.dll

;################################################################################
;#				Check Messages					#
;################################################################################

StartLoop:
	INVOKE	GetMessage,ADDR msg,NULL,NULL,NULL					;user32.dll

	or	eax,eax
	je	EndLoop

	INVOKE	TranslateMessage,ADDR msg						;user32.dll

	INVOKE	DispatchMessage,ADDR msg						;user32.dll

	jmp	StartLoop
EndLoop:

;================================================================================

	mov	eax,msg.wParam
	ret

WinMain ENDP