WndProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL	hdc:HDC 
	LOCAL	ps:PAINTSTRUCT 
	LOCAL	Rect:RECT

	mov	eax,uMsg
	cmp	eax,WM_CREATE
	jne	WP0001

	mov	eax,ZeroReal4
	mov	RotX,eax
	mov	RotY,eax
	mov	RotZ,eax

	INVOKE	CreateWindowEx,WS_EX_STATICEDGE,ADDR TPFPalClass,NULL,\			;user32.dll
		WS_CHILD or WS_VISIBLE or WS_CLIPCHILDREN,0,0,102,50,\
		hWnd,IDC_TPF3DPAL,hInstance,NULL

	mov	hwndTPF3DPal,eax

	push	ebx
	push	edi
	push	esi

	xor	ebx,ebx
	lea	edi,szRotateX
	mov	esi,5

WP0000y:

	INVOKE	CreateWindowEx,NULL,ADDR StaticClass,edi,\			;user32.dll
		WS_CHILD or WS_VISIBLE or SS_LEFT,esi,7,65,20,\
		hwndTPF3DPal,65535,hInstance,NULL

	INVOKE	SendMessage,eax,WM_SETFONT,hGLFont,TRUE

	add	esi,100
	add	edi,14
	inc	ebx
	cmp	bl,3
	jb	WP0000y

	xor	ebx,ebx
	lea	edi,hwndX
	mov	esi,70

WP0000z:

	INVOKE	CreateWindowEx,WS_EX_CLIENTEDGE,ADDR EditClass,NULL,\	;user32.dll
		WS_CHILD or WS_VISIBLE or ES_LEFT or ES_OEMCONVERT or ES_NUMBER,esi,3,26,20,\
		hwndTPF3DPal,ebx,hInstance,NULL

	mov	DWORD PTR[edi+4*ebx],eax

	INVOKE	SendMessage,eax,WM_SETFONT,hGLFont,TRUE

	add	esi,100
	inc	ebx
	cmp	bl,3
	jb	WP0000z

	INVOKE	CreateWindowEx,NULL,ADDR StaticClass,ADDR szText,\			;user32.dll
		WS_CHILD or WS_VISIBLE or SS_LEFT,5,31,25,20,\
		hwndTPF3DPal,65535,hInstance,NULL

	INVOKE	SendMessage,eax,WM_SETFONT,hGLFont,TRUE

	INVOKE	CreateWindowEx,WS_EX_CLIENTEDGE,ADDR EditClass,NULL,\	;user32.dll
		WS_CHILD or WS_VISIBLE or ES_LEFT or ES_OEMCONVERT,30,27,166,20,\
		hwndTPF3DPal,ebx,hInstance,NULL

	mov	DWORD PTR[edi+4*ebx],eax

	INVOKE	SendMessage,eax,WM_SETFONT,hGLFont,TRUE

	inc	ebx

	INVOKE	CreateWindowEx,NULL,ADDR TPFGLPalClass,NULL,\	;user32.dll
		WS_CHILD or WS_VISIBLE or WS_DLGFRAME,206,27,20,20,\
		hwndTPF3DPal,ebx,hInstance,NULL

	mov	DWORD PTR[edi+4*ebx],eax
	inc	ebx

	INVOKE	CreateWindowEx,NULL,ADDR ButtonClass,ADDR szFont,\	;user32.dll
		WS_CHILD or WS_VISIBLE or BS_NOTIFY,236,27,60,20,\
		hwndTPF3DPal,ebx,hInstance,NULL

	mov	DWORD PTR[edi+4*ebx],eax

	INVOKE	SendMessage,eax,WM_SETFONT,hGLFont,TRUE

	INVOKE	CreateCompatibleDC,hDCComputer							;gdi32.dll

	mov	hdcGL,eax

	INVOKE	CreateCompatibleDC,hDCComputer							;gdi32.dll

	mov	hdcText,eax

	INVOKE	CreateDIBSection,hDCComputer,ADDR GLBitmapInfoHeader,DIB_RGB_COLORS,ADDR lpGLBits,NULL,0	;gdi32.dll

	mov	hbmpGL,eax

	INVOKE	SelectObject,hdcGL,eax	;gdi32.dll

	mov	hbmpOldGL,eax

	INVOKE	CreateDIBSection,hDCComputer,ADDR TextBitmapInfoHeader,DIB_RGB_COLORS,ADDR lpTextBits,NULL,0	;gdi32.dll

	mov	hbmpText,eax

	INVOKE	SelectObject,hdcText,eax	;gdi32.dll

	mov	hbmpOldText,eax

	INVOKE	CreateWindowEx,WS_EX_STATICEDGE,ADDR TPFTextClass,NULL,\			;user32.dll
		WS_CHILD or WS_VISIBLE or WS_CLIPCHILDREN,0,0,102,50,\
		hWnd,NULL,hInstance,NULL

	mov	hwndGLText,eax

	mov	PixelFormatDescriptor.nSize,sizeof PIXELFORMATDESCRIPTOR
	mov	PixelFormatDescriptor.nVersion,1
	mov	PixelFormatDescriptor.dwFlags,PFD_DRAW_TO_WINDOW or PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_SWAP_EXCHANGE
	mov	PixelFormatDescriptor.iPixelType,PFD_TYPE_RGBA
	mov	PixelFormatDescriptor.cColorBits,32
	mov	PixelFormatDescriptor.cDepthBits,32

	INVOKE	ChoosePixelFormat,hdcGL,ADDR PixelFormatDescriptor	;gdi32.dll

	or	eax,eax
	mov	edx,eax
	jz	WP0000a

	INVOKE	SetPixelFormat,hdcGL,edx,ADDR PixelFormatDescriptor	;gdi32.dll

	INVOKE	wglCreateContext,hdcGL	;opengl32.dll

	mov	hrcGL,eax

	INVOKE	wglMakeCurrent,hdcGL,eax	;opengl32.dll

	INVOKE	glViewport,0,0,1024,1024

	INVOKE	glMatrixMode,GL_PROJECTION

	INVOKE	glLoadIdentity	;opengl32.dll

	INVOKE	glMatrixMode,GL_MODELVIEW

	INVOKE	glLoadIdentity	;opengl32.dll

	lea	ecx,OneReal8
	mov	eax,DWORD PTR[ecx]
	mov	edx,DWORD PTR[ecx+4]

	INVOKE	glClearDepth,eax,edx	;opengl32.dll

	INVOKE	glHint,GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST	;opengl32.dll

	INVOKE	glClearColor,0,0,0,OneReal4	;opengl32.dll

	INVOKE	glEnable,GL_NORMALIZE	;opengl32.dll

	INVOKE	glEnable,GL_CULL_FACE	;opengl32.dll

	INVOKE	CreateFontIndirect,ADDR OpenGLFont

	mov	hTextFont,eax				;Normal Font

	INVOKE	SelectObject,hdcGL,eax	;gdi32.dll

	INVOKE	glGenLists,256		;opengl32.dll

	mov	fontlist,eax

	INVOKE	wglUseFontOutlines,hdcGL,0,255,eax,OnethousandthReal4,TwotenthReal4,WGL_FONT_POLYGONS,NULL	;opengl32.dll

	INVOKE	glEnable,GL_LIGHTING	;opengl32.dll

	jmp	WP0000b

WP0000a:

	pop	esi
	pop	edi
	pop	ebx

	INVOKE	DestroyWindow,hWnd	;user32.dll

	xor	eax,eax
	ret

WP0000b:

	pop	esi
	pop	edi
	pop	ebx

	jmp	WP0001a

WP0001:

	cmp	eax,WM_WINDOWPOSCHANGED
	mov	edx,lParam
	jne	WP0001z

	and	DWORD PTR[edx+24],SWP_NOSIZE
	jnz	WP0086

WP0001a:

	INVOKE	GetClientRect,hWnd,ADDR Rect				;user32.dll

	sub	Rect.bottom,51

	INVOKE	MoveWindow,hwndGLText,0,0,Rect.right,Rect.bottom,TRUE	;user32.dll

	add	Rect.bottom,1

	INVOKE	MoveWindow,hwndTPF3DPal,0,Rect.bottom,Rect.right,50,TRUE	;user32.dll

	xor	eax,eax
	ret

WP0001z:

	cmp	eax,WM_PAINT
	jne	WP0002

	INVOKE	BeginPaint,hWnd,ADDR ps				;user32.dll

	mov	hdc,eax

	INVOKE	EndPaint,hWnd,ADDR ps				;user32.dll

	xor	eax,eax
	ret
WP0002:
	cmp	eax,WM_DESTROY
	jne	WP0086

	INVOKE	glDeleteLists,fontlist,256	;opengl32.dll

	INVOKE	wglMakeCurrent,hdcGL,NULL	;opengl32.dll

	INVOKE	wglDeleteContext,hrcGL		;opengl32.dll

	INVOKE	SelectObject,hdcGL,hbmpOldGL		;gdi32.dll

	INVOKE	DeleteObject,eax			;gdi32.dll

	INVOKE	DeleteDC,hdcGL				;gdi32.dll

	INVOKE	SelectObject,hdcText,hbmpOldText	;gdi32.dll

	INVOKE	DeleteObject,eax			;gdi32.dll

	INVOKE	DeleteDC,hdcText			;gdi32.dll

	INVOKE	DeleteDC,hDCComputer			;gdi32.dll

	INVOKE	DeleteObject,hTextFont			;gdi32.dll

	INVOKE	PostQuitMessage,NULL				;user32.dll	FINISHED

	xor	eax,eax
	ret
WP0086:
	INVOKE	DefWindowProc,hWnd,uMsg,wParam,lParam		;user32.dll

	ret

WndProc ENDP